<template>
	<mind-view>
		<template v-slot:toolbar-actions>
			<el-button type="primary" size="small" @click="$refs.formulario?.onSubmit()" :disabled="!modificado" >Aplicar Cambios</el-button>
		</template>
		<mind-form  
			v-model="recurso"  v-model:modified="modificado"
			@submit="onSubmit" v-loading="isLoading"
			ref="formulario" 
			>
			<template v-slot="{form}">
					<el-row  >
						<el-col  :lg="8">
							<el-form-item  label="Movil" prop="movil">
								<el-input-number v-model.number="form.movil" :disabled="!isNew"/>
							</el-form-item>
						</el-col>
						<el-col :offset="4" :lg="12">
							<el-form-item  label="Patente" prop="patente">
										<el-input v-model="form.patente" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Activo">
								<el-checkbox  v-model="form.activo" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item  label="Esquema Comisión" prop="idComision">
								<el-select v-model="form.idComision" >
									<el-option
										v-for="item in listaComisiones"
										:key="item.id"
										:label="`${item.nombre} (${item.comision}%)`"
										:value="item.id">
									</el-option>
								</el-select>
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
							<el-col  :lg="12">
								<el-form-item label="Marca" prop="marca">
									<el-input placeholder="Marca" type="text" v-model="form.marca" />
								</el-form-item>
							</el-col>
							<el-col :lg="12">
								<el-form-item  label="Modelo" prop="modelo">
									<el-input clearable placeholder="Modelo" v-model="form.modelo" />
								</el-form-item>
							</el-col>
							<el-col :lg="12">
								<el-form-item  label="Año">
									<el-input-number controls-position="right" placeholder="Año" v-model="form.año" />
								</el-form-item>
							</el-col>
							<el-col :lg="12">
								<el-form-item  label="Color">
									<el-input placeholder="Color" v-model="form.color" />
								</el-form-item>
							</el-col>
					</el-row>
					<el-row  >
							<el-col >
								<el-form-item label="Detalles">
									<el-input type="textarea" v-model="form.detalles" rows="5"/>
								</el-form-item>
							</el-col>
					</el-row>

			</template>
		</mind-form>
	</mind-view>
</template>
<script>
import moviles from '@/model/moviles'
import comisiones from '@/model/comisiones'
// import comisiones from '@/model/comisiones'

export default {
	async created(){
		this.isLoading = true;
		let id = this.$route.params.id;
		comisiones.fetch({})
		.then((response)=>{
			this.listaComisiones = response.value
		})
		if (id == "new") {
			this.recurso = moviles.new()
		} else {
			this.recurso = await moviles.get(id)

		}
		this.isLoading = false;

	},
	computed: {
	},

	methods: {
		async onSubmit(v) {
			delete(v.ultimaActualizacion)
			delete(v.estado)
			this.recurso = v
			const key = moviles.getKey()
			const esNuevo = this.esNuevo
			if(esNuevo) {
				this.recurso = await moviles.post(this.recurso)
				.then((response)=>{
					const id = response[0][key]
					this.$message({
						type: 'success',
						message: `Movil creado correctamente`,
					})
					//modifico la ruta
					const path = this.$router.currentRoute.path.replace(/\/new$/, `/${id}`)
					this.$router.replace(path)
				})
			} else {
				this.recurso = await moviles.patch(this.recurso)
				this.$message({
					type: 'success',
					message: "Movil actualizado correctamente",
				})
			}

		},

	},
	data() {
		return {
			recurso: {},
			modificado: false,
			listaComisiones: [],
			rules: {
				marca: [
					// Rules.required,
					// Rules.noWhitespace
				],
				modelo: [
					// Rules.required
				],
				idComision: [
					// Rules.required
				],
				movil: [
					// Rules.required
				],
				patente: [
					// Rules.required
				],
			},
		}
	}
}
</script>